/**
 * See comment on 'FolderPermissionChecker' -- explains how these scopes are non-overlapping, and refer to distinct
 * different layers in the tree, relative to the current folder.
 */
export type PathPermissionScope = "This" | "Children" | "Grandchildren+";

export namespace PathPermissionScope {
  const allRecord: Record<PathPermissionScope, null> = {
    "Grandchildren+": null,
    "Children": null,
    "This": null
  };
  export const all = Object.keys(allRecord) as PathPermissionScope[];
}
