export type PathVariable = PathVariableStandard | PathVariableUniqueTokenExplicit;

/**
 * IMPORTANT: these variables MUST NOT include "/" characters.
 */
export type PathVariableStandard =
  | "ORIGINAL_FILE_NAME"
  | "ORIGINAL_FILE_EXT" // Includes leading "." if an extension exists, else is empty string "".
  | "UTC_DATE"
  | "UTC_TIME"
  | "UTC_YEAR"
  | "UTC_MONTH"
  | "UTC_DAY"
  | "UTC_HOUR"
  | "UTC_MINUTE"
  | "UTC_SECOND"
  | "UTC_MILLISECOND";

export type PathVariableUniqueTokenExplicit =
  // Attempt once with the entropy size specified 'UNIQUE_DIGITS_<HERE>'. On conflict, return an error.
  | "UNIQUE_DIGITS_1"
  | "UNIQUE_DIGITS_2"
  | "UNIQUE_DIGITS_3"
  | "UNIQUE_DIGITS_4"
  | "UNIQUE_DIGITS_5"
  | "UNIQUE_DIGITS_6"
  | "UNIQUE_DIGITS_7"
  | "UNIQUE_DIGITS_8"
  | "UNIQUE_DIGITS_9"
  | "UNIQUE_DIGITS_10"
  | "UNIQUE_DIGITS_11"
  | "UNIQUE_DIGITS_12"
  | "UNIQUE_DIGITS_13"
  | "UNIQUE_DIGITS_14"
  | "UNIQUE_DIGITS_15"
  | "UNIQUE_DIGITS_16"
  | "UNIQUE_DIGITS_17"
  | "UNIQUE_DIGITS_18"
  | "UNIQUE_DIGITS_19"
  | "UNIQUE_DIGITS_20";

export namespace PathVariable {
  export const utcYear: PathVariable = "UTC_YEAR";
  export const utcMonth: PathVariable = "UTC_MONTH";
  export const utcDay: PathVariable = "UTC_DAY";
  export const originalFileName: PathVariable = "ORIGINAL_FILE_NAME";
  export const originalFileNameExt: PathVariable = "ORIGINAL_FILE_EXT";
  export const uniqueToken4: PathVariable = "UNIQUE_DIGITS_4";
  const allObj: Record<PathVariable, null> = {
    ORIGINAL_FILE_NAME: null,
    ORIGINAL_FILE_EXT: null,
    UTC_DATE: null,
    UTC_TIME: null,
    UTC_YEAR: null,
    UTC_MONTH: null,
    UTC_DAY: null,
    UTC_HOUR: null,
    UTC_MINUTE: null,
    UTC_SECOND: null,
    UTC_MILLISECOND: null,
    UNIQUE_DIGITS_1: null,
    UNIQUE_DIGITS_2: null,
    UNIQUE_DIGITS_3: null,
    UNIQUE_DIGITS_4: null,
    UNIQUE_DIGITS_5: null,
    UNIQUE_DIGITS_6: null,
    UNIQUE_DIGITS_7: null,
    UNIQUE_DIGITS_8: null,
    UNIQUE_DIGITS_9: null,
    UNIQUE_DIGITS_10: null,
    UNIQUE_DIGITS_11: null,
    UNIQUE_DIGITS_12: null,
    UNIQUE_DIGITS_13: null,
    UNIQUE_DIGITS_14: null,
    UNIQUE_DIGITS_15: null,
    UNIQUE_DIGITS_16: null,
    UNIQUE_DIGITS_17: null,
    UNIQUE_DIGITS_18: null,
    UNIQUE_DIGITS_19: null,
    UNIQUE_DIGITS_20: null
  };
  export const all = Object.keys(allObj) as PathVariable[];
}
