import { Milliseconds, MillisecondsUnboxed } from "@upload-io/upload-shared-iso-lite";
import { IsoObjectUtils } from "@upload-io/upload-shared-iso/common/IsoObjectUtils";

// 'epochValue' can be epoch month, epoch day, etc.
export interface DurationByEpochDto {
  [epochValue: string]: Milliseconds | undefined;
}

export interface DurationByEpochUnboxedDto {
  [epochValue: string]: MillisecondsUnboxed | null;
}

export namespace DurationByEpochDto {
  export function combine(left: DurationByEpochDto, right: DurationByEpochDto): DurationByEpochDto {
    return IsoObjectUtils.fullOuterJoin(left, right, (a: number, b: number) => Milliseconds(a + b));
  }
}
