import { StorageStatisticsByTimeDto, StorageStatisticsSegmentDto } from "@upload-io/upload-shared-iso";
import { StorageStatisticsSegmentUnboxedDto } from "@upload-io/upload-shared-iso/statistics/storage/dtos/shared/StorageStatisticsSegmentDto";
import {
  CreatesAndDeletesByTimeDto,
  StorageStatisticsByTimeUnboxedDto
} from "@upload-io/upload-shared-iso/statistics/storage/dtos/shared/StorageStatisticsByTimeDto";

export interface PermaCacheStatisticsDto {
  all: StorageStatisticsSegmentDto;
  byTime: StorageStatisticsByTimeDto;
}

export interface PermaCacheStatisticsUnboxedDto {
  all: StorageStatisticsSegmentUnboxedDto;
  byTime: StorageStatisticsByTimeUnboxedDto;
}

export namespace PermaCacheStatisticsDto {
  export const empty: PermaCacheStatisticsDto = {
    all: StorageStatisticsSegmentDto.empty,
    byTime: CreatesAndDeletesByTimeDto.empty
  };

  export function combine(left: PermaCacheStatisticsDto, right: PermaCacheStatisticsDto): PermaCacheStatisticsDto {
    return {
      all: StorageStatisticsSegmentDto.combine(left.all, right.all),
      byTime: CreatesAndDeletesByTimeDto.combine(left.byTime, right.byTime)
    };
  }
}
