import {
  StorageStatisticsSegmentDto,
  StorageStatisticsSegmentUnboxedDto
} from "@upload-io/upload-shared-iso/statistics/storage/dtos/shared/StorageStatisticsSegmentDto";
import {
  UploadStatisticsDto,
  UploadStatisticsUnboxedDto
} from "@upload-io/upload-shared-iso/statistics/storage/dtos/shared/UploadStatisticsDto";
import {
  PermaCacheStatisticsDto,
  PermaCacheStatisticsUnboxedDto
} from "@upload-io/upload-shared-iso/statistics/storage/dtos/shared/PermaCacheStatisticsDto";

export interface StorageStatisticsDto {
  all: StorageStatisticsSegmentDto;
  permaCache: PermaCacheStatisticsDto | undefined; // 'undefined' for backwards compatibility.
  uploads: UploadStatisticsDto;
}

export interface StorageStatisticsUnboxedDto {
  all: StorageStatisticsSegmentUnboxedDto;
  permaCache: PermaCacheStatisticsUnboxedDto | null;
  uploads: UploadStatisticsUnboxedDto;
}

export namespace StorageStatisticsDto {
  export const empty: StorageStatisticsDto = {
    all: StorageStatisticsSegmentDto.empty,
    permaCache: PermaCacheStatisticsDto.empty,
    uploads: UploadStatisticsDto.empty
  };

  export function combine(left: StorageStatisticsDto, right: StorageStatisticsDto): StorageStatisticsDto {
    return {
      all: StorageStatisticsSegmentDto.combine(left.all, right.all),
      uploads: UploadStatisticsDto.combine(left.uploads, right.uploads),
      permaCache: PermaCacheStatisticsDto.combine(
        left.permaCache ?? PermaCacheStatisticsDto.empty,
        right.permaCache ?? PermaCacheStatisticsDto.empty
      )
    };
  }
}
